#include "paps.h"


struct pseudo_udp_hdr {
    struct in_addr saddr;
    struct in_addr daddr;
    unsigned char zero;
    unsigned char protocol;
    unsigned short length;
    struct udphdr udp;
};

struct pseudo_tcp_hdr {
    unsigned long saddr;
    unsigned long daddr;
    unsigned char zero;
    unsigned char protocol;
    unsigned short length;
    struct tcphdr tcp;
};

int tcp_sender(unsigned char *decoy_hw, long decoy, long target, int scan_type, struct port_list *ports)
{
  struct ethhdr *ethh;
  struct iphdr *iph;
  struct tcphdr *tcph;
  struct ifreq ifr;
  static struct sockaddr_ll sa;
  struct pseudo_tcp_hdr *pseudo;
  unsigned char pkt[sizeof(struct ethhdr)+sizeof(struct iphdr)+sizeof(struct tcphdr)];
  int i, sck_num;
  unsigned char buf[sizeof(struct pseudo_tcp_hdr)];
  
   
  read(rand_fd, &sck_num, sizeof(int)); sck_num = abs(sck_num) % SOCKS_COUNT;
      
  strncpy(ifr.ifr_name, dev, sizeof(ifr.ifr_name));
  if(ioctl(socks[sck_num], SIOCGIFINDEX, &ifr)<0)
      { perror("ioctl SIOCGIFINDEX ");
        exit(1); }
  
  memset(&sa, 0, sizeof(struct sockaddr_ll));
 
  sa.sll_family = AF_INET;
  sa.sll_protocol = htons(ETH_P_IP);
  sa.sll_ifindex = ifr.ifr_ifindex;
            
  memset(pkt, 0, sizeof(pkt));
  
  ethh=(struct ethhdr *)pkt;  
  memcpy(ethh->h_dest, gateway, ETH_ALEN);
  memcpy(ethh->h_source, decoy_hw, ETH_ALEN);
  ethh->h_proto = htons(ETH_P_IP);
  
  iph=(struct iphdr *)(pkt+sizeof(struct ethhdr));
  iph->version = 4;
  iph->ttl = 128;
  iph->protocol=IPPROTO_TCP;
  iph->saddr = decoy;
  iph->daddr = target;
  iph->tot_len = htons(sizeof(struct iphdr)+sizeof(struct tcphdr));
  iph->ihl = sizeof(*iph) / 4;
 
  tcph=(struct tcphdr *)(pkt + sizeof(struct ethhdr) + sizeof(struct iphdr));
  tcph->th_win = htons(4096);
  tcph->th_off = sizeof(struct tcphdr) / 4;  

  pseudo = (struct pseudo_tcp_hdr *)buf;
  pseudo->daddr = target;
  pseudo->saddr = decoy;
  pseudo->protocol = IPPROTO_TCP;
  pseudo->length = htons(sizeof(struct tcphdr));
  pseudo->zero = 0;
  

  for(i=0;i<ports->count;i++)  
    {                                               
      if(scan_type != RAND_SCAN) 
        tcph->th_flags = scan_type; 
      else
        tcph->th_flags = ports->type[i];
      
      read(rand_fd, &tcph->th_seq, sizeof(u_int32_t));
      read(rand_fd, &tcph->th_sport, sizeof(u_int16_t));
      tcph->th_dport=htons(ports->port[i]);
      tcph->th_sum = 0;
     
      memcpy(&pseudo->tcp, tcph, sizeof(struct tcphdr));
      tcph->th_sum = in_cksum((u_16 *)&buf, sizeof(struct pseudo_tcp_hdr));
      
      read(rand_fd, &iph->id, sizeof(u_int16_t));
      iph->check = 0;
      iph->check = in_cksum((u_16 *)iph, sizeof(struct iphdr));
            
      if(sendto(socks[sck_num], pkt, sizeof(pkt), 0, (struct sockaddr *)&sa, sizeof(sa))<0)
         perror("sendto ");
            
     }     
 
 return 0;  
}

void tcp_receiver(long decoy, long target, int scan_type, struct port_list *ports)
{
  pcap_t *p;
  fd_set rfd;
  struct bpf_program filter;
  struct pcap_pkthdr hdr;
  struct iphdr *ip;
  struct tcphdr *tcp;
  struct timeval timeout;
  char filter_app[100];
  char src[50], dst[50];
  int sockfd, net, mask, count, n;
  char *pkt;


  inet_ntop(PF_INET, &decoy, src, sizeof(src));
  inet_ntop(PF_INET, &target, dst, sizeof(dst));


  if((p = pcap_open_live(dev, 100, 1, ports->count, pcap_ebuf)) == NULL)
    { fprintf(stderr, "%s\n", pcap_ebuf);
      exit(1); }
  
  
  snprintf(filter_app, sizeof(filter_app), "(tcp[13]&2!=0 or tcp[13]&4!=0) and src host %s", target_ip);


  if(pcap_lookupnet(dev, &net, &mask, pcap_ebuf) < 0)
    { fprintf(stderr, "%s\n", pcap_ebuf);
      exit(1); }

  if(pcap_compile(p, &filter, filter_app, 0, net) < 0)
    { fprintf(stderr, "%s\n", pcap_geterr(p));
      exit(1); }

  if(pcap_setfilter(p, &filter) < 0)
    { fprintf(stderr, "Couldn't set filter\n");
      exit(1); }
  
        
  memset(&timeout, 0, sizeof(struct timeval));
  timeout.tv_sec = time_for_waiting; 
  
  count = ports->count;
    
  sockfd=pcap_fileno(p);
  FD_ZERO(&rfd);
  FD_SET(sockfd, &rfd);
  
  
  while((count > 0)&&(select(sockfd+1, &rfd, NULL, NULL, &timeout)>0))
    {     
      FD_SET(sockfd, &rfd);
      pkt = (char *)pcap_next(p, &hdr);
      ip = (struct iphdr *)(pkt + sizeof(struct ethhdr));
      tcp = (struct tcphdr *)(pkt + sizeof(struct ethhdr) + (ip->ihl << 2));
  
      n = 0;
      for (n = 0; ports->count; n++)
        {
          if (ports->port[n] == ntohs(tcp->th_sport))
              break;
        }
        	  
      if(n==ports->count) 
	  continue;   	    	    
	  
      switch ( (scan_type != RAND_SCAN) ? scan_type : ports->type[n] )
	{
	  case SYN_SCAN:
	    {  
	      if ((tcp->th_flags&TH_SYN)&&(tcp->th_flags&TH_ACK))
	           ports->state[n] = 1;	
               else if (tcp->th_flags&TH_RST)
                   ports->state[n] = 2; 
               break;
             }
          default:
	     {
	       if (tcp->th_flags&TH_RST)
	 	   ports->state[n] = 2;
               break;
             }
	}
      
      if(--count==0) break;
      
    }   
  
  pcap_close(p);
}

int udp_sender(unsigned char *decoy_hw, int decoy, int target, struct port_list *ports)
{
  struct ethhdr *ethh;
  struct iphdr *iph;
  struct udphdr *udph;
  struct ifreq ifr;
  struct sockaddr_ll sa;
  struct pseudo_udp_hdr *pseudo;
  char pkt[sizeof(struct ethhdr)+sizeof(struct iphdr)+sizeof(struct udphdr)];
  char buf[sizeof(struct pseudo_udp_hdr)];
  int sck_num, i;
  
     
  read(rand_fd, &sck_num, sizeof(int)); sck_num = abs(sck_num) % SOCKS_COUNT;
      
  strncpy(ifr.ifr_name, dev, sizeof(ifr.ifr_name));
  if(ioctl(socks[sck_num], SIOCGIFINDEX, &ifr)<0)
      { perror("ioctl IOCGIFINDEX ");
        exit(1); }

              
  memset(&sa, 0, sizeof(struct sockaddr_ll));
  sa.sll_family=PF_INET;
  sa.sll_protocol=htons(ETH_P_IP);
  sa.sll_ifindex=ifr.ifr_ifindex;
  
  memset(pkt, sizeof(pkt), 0);
  
  ethh = (struct ethhdr *)pkt;
  memcpy(ethh->h_dest, gateway, ETH_ALEN);
  memcpy(ethh->h_source, decoy_hw, ETH_ALEN);
  ethh->h_proto = htons(ETH_P_IP);
  
  iph = (struct iphdr *)(pkt+sizeof(struct ethhdr));
  iph->version = 4;
  iph->ttl = 128;
  iph->protocol = IPPROTO_UDP;
  iph->saddr = decoy;
  iph->daddr = target;
  iph->tot_len = htons(sizeof(struct iphdr)+sizeof(struct udphdr));
  iph->ihl = sizeof(*iph)/4;
 
  
  udph = (struct udphdr *)(pkt+sizeof(struct ethhdr)+sizeof(struct iphdr));
  udph->uh_ulen = htons(sizeof(struct udphdr));
  
  pseudo = (struct pseudo_udp_hdr *)buf;
  pseudo->saddr.s_addr = iph->saddr;
  pseudo->daddr.s_addr = iph->daddr;
  pseudo->protocol = IPPROTO_UDP;
  pseudo->length = htons(sizeof(struct udphdr));
  pseudo->zero = 0;
  
      
  for(i=0;i<ports->count;i++)
    {
      read(rand_fd, &udph->uh_sport, sizeof(u_int16_t));
      udph->uh_dport = htons(ports->port[i]);
      udph->uh_sum = 0;
      
      memcpy(&pseudo->udp, udph, sizeof(struct udphdr));
      udph->uh_sum = in_cksum((u_16 *)&buf, sizeof(struct pseudo_udp_hdr));
      
      read(rand_fd, &iph->id, sizeof(u_int16_t));
      iph->check = 0;
      iph->check = in_cksum((u_16 *)iph, sizeof(struct iphdr));
      
      if(sendto(socks[sck_num], pkt, sizeof(pkt), 0, (struct sockaddr *)&sa, sizeof(sa))<0)
        perror("sendto: ");
     }
  
  return 0;
}


void
udp_receiver(int decoy, int target, struct port_list *ports)
{
  pcap_t *p;
  fd_set rfd;
  struct bpf_program filter;
  struct pcap_pkthdr hdr;
  struct iphdr *iph;
  struct udphdr *udph;
  struct timeval timeout;
  char filter_app[128];
  char src[50], dst[50];
  int sockfd, net, mask, count, n;
  char *pkt;

  inet_ntop(PF_INET, &decoy, src, sizeof(src));
  inet_ntop(PF_INET, &target, dst, sizeof(dst));

  if((p = pcap_open_live(dev, 200, 1, ports->count * 2, pcap_ebuf)) == NULL)
    { fprintf(stderr, "%s\n", pcap_ebuf);
      exit(1); }
    
  snprintf(filter_app, sizeof(filter_app), "udp or (icmp and icmp[0]=3) and src host %s", target_ip);
  
  if(pcap_lookupnet(dev, &net, &mask, pcap_ebuf)<0)
    { fprintf(stderr, "%s\n", pcap_ebuf);
      exit(1); }
      
  if(pcap_compile(p, &filter, filter_app, 0, net)<0)
    { fprintf(stderr, "%s\n", pcap_geterr(p));
      exit(1); }

  if(pcap_setfilter(p, &filter)<0)
    { fprintf(stderr, "Couldn't set filter\n");
      exit(1); }

  sockfd=pcap_fileno(p);
         
  memset(&timeout, 0, sizeof(struct timeval));
  timeout.tv_sec = time_for_waiting;
   
  count = ports->count;
  
  FD_ZERO(&rfd);
  FD_SET(sockfd, &rfd);
    
  while((count > 0)&&(select(sockfd+1, &rfd, NULL, NULL, &timeout)>0))
    {
      pkt = (char *)pcap_next(p, &hdr); 
      iph = (struct iphdr *)(pkt + sizeof(struct ethhdr));    
      
    
      if(iph->protocol == IPPROTO_ICMP)
        udph = (struct udphdr *)(pkt+sizeof(struct ethhdr)+sizeof(struct iphdr)+8+sizeof(struct iphdr));
      else
        udph = (struct udphdr *)(pkt + sizeof(struct ethhdr) + sizeof(struct iphdr));
      
            
      n = 0;
      for (n = 0; n < ports->count; n++)
         {
           if (ports->port[n] == ntohs(udph->uh_dport))
              {
                if(iph->protocol == IPPROTO_ICMP)  
                  ports->state[n] = 1;
                else 
                  ports->state[n] = 2;
                break;
              }
         }
      
      if(--count==0) break;
                              		     
      FD_SET(sockfd, &rfd);
   }
  pcap_close(p);
}

unsigned short in_cksum(u_16 *ptr,int nbytes) 
{
 register u_32 sum;
 u_16 oddbyte;	
 register u_16 answer;

 sum = 0;
 while (nbytes > 1)  
   {
     sum += *ptr++;
     nbytes -= 2;
   }

 if (nbytes == 1) 
   {
     oddbyte = 0;            
     *((u_char *) &oddbyte) = *(u_char *)ptr;   
     sum += oddbyte;
   }

 sum  = (sum >> 16) + (sum & 0xffff);    
 sum += (sum >> 16);                     
 answer = ~sum;          
 return(answer);
}
